#include <windows.h>
#include <jni.h>
#include "MSIcon.h"

/*
 * Class:     Pollute
 * Method:    getWindowsDirectory
 * Signature: ()Ljava/lang/String;
 */
//ȡWindowsװ·
JNIEXPORT jstring JNICALL Java_impure_Pollute_getWindowsDirectory
  (JNIEnv * je, jclass)
{
    char buffer[4096];
    GetWindowsDirectory(buffer, 4096);

    //ȡ·AnsiģʽתΪUnicode
    WCHAR Buffer[4096];
    MultiByteToWideChar(CP_ACP, MB_COMPOSITE, buffer, 4096, Buffer, 4096);

    return je->NewString(Buffer, lstrlenW(Buffer));
}

/*
 * Class:     Pollute
 * Method:    getSystemDirectory
 * Signature: ()Ljava/lang/String;
 */
//ȡWindowsϵͳĿ¼·
JNIEXPORT jstring JNICALL Java_impure_Pollute_getSystemDirectory
  (JNIEnv *je, jclass)
{
    char buffer[4096];
    GetSystemDirectory(buffer, 4096);

    //ȡ·AnsiģʽתΪUnicode
    WCHAR Buffer[4096];
    MultiByteToWideChar(CP_ACP, MB_COMPOSITE, buffer, 4096, Buffer, 4096);

    return je->NewString(Buffer, lstrlenW(Buffer));
}

/*
 * Class:     Pollute
 * Method:    shellOpen
 * Signature: (Ljava/lang/String;)V
 */
//ʹWindowsϵͳĬϴ򿪷ʽһļ
JNIEXPORT void JNICALL Java_impure_Pollute_shellOpen
  (JNIEnv *je, jclass, jstring filename)
{
    jboolean False=false;

    //JavaдݹUnicodeַתΪAnsiģʽ
    char buffer[1024];
    wsprintf(buffer, "%ls", je->GetStringChars(filename, &False));

    ShellExecute(NULL, NULL, buffer, NULL, NULL, SW_SHOW);
}

/*
 * Class:     Pollute
 * Method:    getIconCount
 * Signature: (Ljava/lang/String;)I
 */
//ȡһļаͼĸ
JNIEXPORT jint JNICALL Java_impure_Pollute_getIconCount
  (JNIEnv *je, jclass, jstring filename)
{
    jboolean False=false;

    //JavaдݹUnicodeַתΪAnsiģʽ
    char buffer[1024];
    wsprintf(buffer, "%ls", je->GetStringChars(filename, &False));

    return (jint)ExtractIcon(NULL, buffer, -1);
}

/*
 * Class:     Pollute
 * Method:    extractIconData
 * Signature: (Ljava/lang/String;I[[I[[ZZ)V
 */
//ļȡһͼ
JNIEXPORT void JNICALL Java_impure_Pollute_extractIconData
  (JNIEnv *je, jclass, jstring filename, jint index, jobjectArray Image, jobjectArray Mask, jboolean isLarge)
{
    jboolean False=false;
    HICON hLarge=NULL, hSmall=NULL;
    int size;

    if(isLarge)
        size=32;
    else
        size=16;

    HDC hDC=GetDC(0);
    HDC memDC=CreateCompatibleDC(hDC);
    HBITMAP memBM=CreateCompatibleBitmap(hDC, size, size);
    SelectObject(memDC, memBM);

    //JavaдݹUnicodeַתΪAnsiģʽ
    char buffer[1024];
    wsprintf(buffer, "%ls", je->GetStringChars(filename, &False));
    ExtractIconEx(buffer, index, &hLarge, &hSmall, 1);

    //ڴDCлͼת浽Java
    if(isLarge)
        DrawIconEx(memDC, 0, 0, hLarge, 32, 32, 0, NULL, DI_IMAGE);
    else
        DrawIconEx(memDC, 0, 0, hSmall, 16, 16, 0, NULL, DI_IMAGE);

    for(int y=0; y<size; y++)
    {
        jint *i=new jint[size];
        jobject line=je->GetObjectArrayElement(Image, y);
        for(int x=0; x<size; x++)
        {
            int Color=GetPixel(memDC, x, y);
            i[x]=GetRValue(Color)*0x10000+GetGValue(Color)*0x100+GetBValue(Color);
        }

        je->SetIntArrayRegion((jintArray)line, 0, size, i);
        delete []i;
    }

    //ڴDCл벢ת浽Java
    if(isLarge)
        DrawIconEx(memDC, 0, 0, hLarge, 32, 32, 0, NULL, DI_MASK);
    else
        DrawIconEx(memDC, 0, 0, hSmall, 16, 16, 0, NULL, DI_MASK);

    for(y=0; y<size; y++)
    {
        jboolean *i=new jboolean[size];
        jobject line=je->GetObjectArrayElement(Mask, y);
        for(int x=0; x<size; x++)
            i[x]=(GetPixel(memDC, x, y)!=0);
        je->SetBooleanArrayRegion((jbooleanArray)line, 0, size, i);
        delete []i;
    }

    DestroyIcon(hLarge);
    DestroyIcon(hSmall);

    DeleteObject(memBM);
    DeleteDC(memDC);
    ReleaseDC(0, hDC);
}
