package components.mainframe;

import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class AboutDlg extends JDialog
{
    public AboutDlg(
        Frame owner,
        String title,
        Icon icon,
        String information,
        Dimension size)
    {
        super(owner, title, true);
        JPanel top = new JPanel();
        JPanel bottom = new JPanel();

        JButton jbOK = new JButton(Resource.DialogOK);
        jbOK.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                AboutDlg.this.dispose();
            }
        });

        top.add(new JLabel(icon));
        top.add(new JLabel(information));

        bottom.add(jbOK);

        getContentPane().add(top, "Center");
        getContentPane().add(bottom, "South");
        getRootPane().setDefaultButton(jbOK);

        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

        if (size == null)
            pack();
        else
            setSize(size);

        try
        {
            setLocation(
                getParent().getX() + (getParent().getWidth() - getWidth()) / 2,
                getParent().getY()
                    + (getParent().getHeight() - getHeight()) / 2);
        }
        catch (NullPointerException e)
        {
            setLocation(
                (Toolkit.getDefaultToolkit().getScreenSize().width
                    - getWidth())
                    / 2,
                (Toolkit.getDefaultToolkit().getScreenSize().height
                    - getHeight())
                    / 2);
        }
        SwingUtilities.updateComponentTreeUI(this);

        setResizable(false);
        show();
    }
}
