package components.toolbox;

import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class LinePanel extends JPanel implements MouseListener
{
    private int width;

    public void mouseClicked(MouseEvent e)
    {}

    public void mouseEntered(MouseEvent e)
    {}

    public void mouseExited(MouseEvent e)
    {}

    public void mousePressed(MouseEvent e)
    {
        if (e.getButton() != MouseEvent.BUTTON1)
            return;

        int y = (e.getPoint().y - 2) / 10;

        if (y < 0 || y > 5)
            return;

        width = y;
        repaint();
    }

    public void mouseReleased(MouseEvent e)
    {}

    protected int getLineWidth()
    {
        return width + 1;
    }

    protected LinePanel()
    {
        width = 0;
        addMouseListener(this);
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(64, 64);
    }

    public Dimension getMaximumSize()
    {
        return new Dimension(64, 64);
    }

    public Dimension getMinimumSize()
    {
        return new Dimension(64, 64);
    }

    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        g.drawImage(Resource.ImageLineWidth, 0, 0, 64, 64, this);

        g.setColor(Color.BLUE);
        g.drawRect(0, width * 10 + 2, 63, 9);
    }
}
