package msicon;

import java.awt.*;
import java.io.*;
import java.util.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ͼ࣬
 * ڹͼļݡ</p>*/

public class MSIcon implements Serializable
{
    private boolean cursor;
    private ArrayList IconData;

    /**һͼļ
     * ע⣬ٱһͼݺſԴ̡*/
    public MSIcon()
    {
        IconData = new ArrayList();
    }

    /**ʹͼݴһͼļ*/
    public MSIcon(MSIconData Data)
    {
        IconData = new ArrayList();
        IconData.add(Data);
    }

    /**ʹͼ鴴ͼļ*/
    public MSIcon(ArrayList Data) throws RuntimeException
    {
        try
        {
            MSIconData msid;
            for (int i = 0; i < Data.size(); i++)
                msid = (MSIconData) (Data.get(i));
            IconData = Data;
        }
        catch (RuntimeException e)
        {
            throw e;
        }
    }

    /**ļװһͼꡣ*/
    public MSIcon(String filename) throws Exception
    {
        if (!flowIn(filename))
            throw new Exception();
    }

    /**ظöǷǹꡣ*/
    public boolean isCursor()
    {
        return cursor;
    }

    /**ظöǷͼꡣ*/
    public boolean isIcon()
    {
        return !cursor;
    }

    /**ѸöΪꡣ*/
    public void setCursor()
    {
        cursor = true;
    }

    /**ѸöΪͼꡣ*/
    public void setIcon()
    {
        cursor = false;

        for (int i = 0; i < IconData.size(); i++)
             ((MSIconData) (IconData.get(i))).setHotspot(0, 0);
    }

    /**һհͼݿӵͼУ
     * Ϊ32
     * ߶Ϊ32
     * ɫΪϵͳĬ16ɫɫ壬
     * ٵλΪ(0, 0)
     * ֵΪռݡ*/
    public MSIconData add()
    {
        MSIconData data = new MSIconData();
        IconData.add(data);
        return data;
    }

    /**һհͼݿӵͼУ
     * Ϊ32
     * ߶Ϊ32
     * ɫΪϵͳĬ16ɫɫ壬
     * ٵλΪ(0, 0)
     * ֵΪռݡ*/
    public MSIconData add(int index)
    {
        MSIconData data = new MSIconData();
        IconData.add(index, data);
        return data;
    }

    /**һͼݿӵͼУ
     * ֵΪռݡ*/
    public MSIconData add(MSIconData data)
    {
        IconData.add(data);
        return data;
    }

    /**һհͼݿӵͼУ
     * ֵΪռݡ*/
    public MSIconData add(MSIconData data, int index)
    {
        IconData.add(index, data);
        return data;
    }

    /**һհͼݿӵͼУ
     * ȸ߶Ϊ<code>size</code>
     * ɫΪ<code>palette</code>
     * ٵλΪhotspot
     * ֵΪռݡ*/
    public MSIconData add(Dimension size, Color[] palette, Point hotspot)
    {
        MSIconData data = new MSIconData(size, palette, hotspot);
        IconData.add(data);
        return data;
    }

    /**һհͼݿӵͼУ
     * ȸ߶Ϊ<code>size</code>
     * ɫΪ<code>palette</code>
     * ٵλΪhotspot
     * ֵΪռݡ*/
    public MSIconData add(
        int index,
        Dimension size,
        Color[] palette,
        Point hotspot)
    {
        MSIconData data = new MSIconData(size, palette, hotspot);
        IconData.add(index, data);
        return data;
    }

    /**һͼݿͼɾ
     * ֵΪɾݿ顣
     * ָݿͼвڣ
     * 򷵻<code>null</code>*/
    public MSIconData remove(int index)
    {
        try
        {
            MSIconData msid = (MSIconData) (IconData.get(index));
            IconData.remove(index);
            return msid;
        }
        catch (Exception e)
        {
            return null;
        }
    }

    /**һͼݿͼɾ
     * ֵΪɾݿ顣
     * ָݿͼвڣ
     * 򷵻<code>null</code>*/
    public MSIconData remove(MSIconData data)
    {
        if (IconData.indexOf(data) == -1)
            return null;

        IconData.remove(data);
        return data;
    }

    /**ȡļеͼ*/
    public int getIconCount()
    {
        return IconData.size();
    }

    /**ص<code>index-1</code>ͼݡ*/
    public MSIconData get(int index)
    {
        return (MSIconData) (IconData.get(index));
    }

    /**޸ĵ<code>index-1</code>ͼݡ*/
    public MSIconData set(int index, MSIconData data)
    {
        return (MSIconData) (IconData.set(index, data));
    }

    /**ͼݴļ뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowIn(String filename)
    {
        try
        {
            DataInputStream dis =
                new DataInputStream(new FileInputStream(filename));
            boolean result = flowIn(dis);
            dis.close();
            return result;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ͼ뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowIn(DataInputStream dis)
    {
        IconData = new ArrayList();
        System.gc();

        try
        {
            int IconHead = Utilities.readInt(dis);
            if (IconHead == 0x020000)
                cursor = true;
            else
            {
                if (IconHead == 0x010000)
                    cursor = false;
                else
                    throw new Exception();
            }

            int IconNum = Utilities.readUShort(dis);

            if (IconNum <= 0)
                throw new Exception();

            for (int i = 0; i < IconNum; i++)
            {
                MSIconData msid = new MSIconData();
                if (msid.flowHeadIn(dis))
                    IconData.add(msid);
                else
                    throw new Exception();
            }

            for (int i = 0; i < IconNum; i++)
            {
                if (!((MSIconData) (IconData.get(i))).flowDataIn(dis))
                    throw new Exception();
            }

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ͼļС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowOut(String filename)
    {
        try
        {
            DataOutputStream dos =
                new DataOutputStream(new FileOutputStream(filename));
            boolean result = flowOut(dos);
            dos.close();
            return result;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ͼָص㡣
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowOut(DataOutputStream dos)
    {
        if (IconData.size() == 0)
            return false;

        try
        {
            if (cursor)
                Utilities.writeInt(0x020000, dos);
            else
                Utilities.writeInt(0x010000, dos);

            Utilities.writeUShort(IconData.size(), dos);

            int Position = 6 + 16 * IconData.size();

            for (int i = 0; i < IconData.size(); i++)
            {
                MSIconData msid = (MSIconData) (IconData.get(i));
                if (!msid
                    .flowHeadOut(dos, msid.getIconDataSize() + 40, Position))
                    throw new Exception();

                Position += 40 + msid.getIconDataSize();
            }

            for (int i = 0; i < IconData.size(); i++)
            {
                if (!((MSIconData) (IconData.get(i))).flowDataOut(dos))
                    throw new Exception();
            }

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ȡͼļС*/
    protected int getIconSize()
    {
        int Position = 6 + 16 * IconData.size();

        for (int i = 0; i < IconData.size(); i++)
        {
            MSIconData msid = (MSIconData) (IconData.get(i));
            Position += 40 + msid.getIconDataSize();
        }

        return Position;
    }
}
