package skeleton;
import msicon.*;
import fsdi.*;

import datatype.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>ĵ࣬ڱ༭ͼϢṩ
 * ȡʹ̹</p>*/

public class AnimationDoc extends FDocument
{
    private MSAni msani;
    private ModifyData Modification;

    public AnimationDoc()
    {
        //addFileFilter(new SunFileFilter("ico", Resource.DescriptionIconFile));
        //addFileFilter(new SunFileFilter("cur", Resource.DescriptionCursorFile));
        addFileFilter(
            new SunFileFilter("ani", Resource.DescriptionAnimationFile));
    }

    /**صǰ༭Ϣ*/
    public ModifyData getModifyData()
    {
        return Modification;
    }

    /**ضݡ*/
    public MSAni getData()
    {
        return msani;
    }

    protected boolean newDocument()
    {
        try
        {
            msani = new MSAni();
            Modification = null;
            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    protected boolean openFile(String Filename)
    {
        try
        {
            MSAni newAni = new MSAni(Filename);
            msani = newAni;
            System.gc();
            Modification = null;
            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    protected boolean saveFile(String Filename)
    {
        ((MainFrame) frame).getAnimation().getSlidePanel().confirmAll();
        return msani.flowOut(Filename);
    }

    synchronized protected Object doModify(Object modifyData)
    {
        Modification = (ModifyData) modifyData;
        ModifyData UndoData = new ModifyData();
        FrameData fdata;

        switch (Modification.Level)
        {
            case 1 :
                switch (Modification.Operation)
                {
                    case 0 :
                        UndoData.Level = 1;
                        UndoData.Operation = 0;
                        UndoData.index = Modification.index;
                        UndoData.Data =
                            new Integer(msani.getRate(Modification.index));
                        msani.setRate(
                            Modification.index,
                            ((Integer) (Modification.Data)).intValue());
                        break;
                    case 1 :
                        UndoData.Level = 1;
                        UndoData.Operation = 2;
                        UndoData.index = Modification.index;
                        UndoData.Data = null;
                        fdata = (FrameData) Modification.Data;
                        int Rate = fdata.Rate;
                        msani.add(Modification.index, fdata.Icon, Rate);
                        break;
                    case 2 :
                        UndoData.Level = 1;
                        UndoData.Operation = 1;
                        UndoData.index = Modification.index;
                        fdata = new FrameData();
                        fdata.Rate = msani.getRate(Modification.index);
                        fdata.Icon = msani.remove(Modification.index);
                        UndoData.Data = fdata;
                        break;
                }
                break;
            case 2 :
                switch (Modification.Operation)
                {
                    case 0 :
                        UndoData.Level = 2;
                        UndoData.Operation = 0;
                        UndoData.index = Modification.index;
                        ImageInfo info = (ImageInfo) (Modification.Data);
                        MSIconData tempdata =
                            msani.getCursor(Modification.index).set(
                                info.index,
                                info.data);
                        info.data = tempdata;
                        UndoData.Data = info;
                        break;
                    case 1 :
                        UndoData.Level = 2;
                        UndoData.Operation = 2;
                        UndoData.index = Modification.index;
                        info = (ImageInfo) (Modification.Data);
                        msani.getCursor(Modification.index).add(
                            info.data,
                            info.index);
                        UndoData.Data = info;
                        info.data = null;
                        break;
                    case 2 :
                        UndoData.Level = 2;
                        UndoData.Operation = 1;
                        UndoData.index = Modification.index;
                        info = (ImageInfo) (Modification.Data);
                        info.data =
                            msani.getCursor(Modification.index).remove(
                                info.index);
                        UndoData.Data = info;
                        break;
                }
                break;
            case 3 :
                switch (Modification.Operation)
                {
                    case 0 :
                        UndoData.Level = 3;
                        UndoData.Operation = 0;
                        UndoData.index = Modification.index;

                        HotspotInfo newInfo = (HotspotInfo) (Modification.Data);
                        HotspotInfo oldInfo = new HotspotInfo();
                        oldInfo.index = newInfo.index;
                        oldInfo.x =
                            msani
                                .getCursor(Modification.index)
                                .get(newInfo.index)
                                .getHotspot()
                                .x;
                        oldInfo.y =
                            msani
                                .getCursor(Modification.index)
                                .get(newInfo.index)
                                .getHotspot()
                                .y;
                        msani.getCursor(Modification.index).get(
                            newInfo.index).setHotspot(
                            newInfo.x,
                            newInfo.y);
                        UndoData.Data = oldInfo;

                        break;
                    case 1 :
                        UndoData.Level = 3;
                        UndoData.Operation = 1;
                        UndoData.index = Modification.index;

                        ImageModify oldData = new ImageModify();
                        ImageModify newData = (ImageModify) (Modification.Data);

                        oldData.index = newData.index;
                        oldData.data =
                            new ImageData(
                                newData.data.getPosition().x,
                                newData.data.getPosition().y,
                                newData.data.getWidth(),
                                newData.data.getHeight(),
                                msani.getCursor(Modification.index).get(
                                    newData.index));
                        newData.data.setImageData(
                            msani.getCursor(Modification.index).get(
                                newData.index));
                        UndoData.Data = oldData;

                        break;
                    case 2 :
                        break;
                }
                break;
        }

        return UndoData;
    }

    /**
     * @see fsdi.FDocument#modify(java.lang.Object)
     */
    public int modify(Object action)
    {
        int size = super.modify(action);
        // ȹ
        // ĳݣ
        // λ
        if (undoDepth > Resource.MaxUndoDepth)
        {
            undostack.remove(0);
            setModifiedFlag(true);
        }
        return undostack.size();
    }
}
