package tinyPainter;

import java.awt.*;
import javax.swing.*;

/**
 * 
 * ˸һЩ
 * ڶڲʱӦıĴСʾ
 * @author gameboy<p>
 * Created on 2002-12-14
 */
public class TPDesktopManager extends DefaultDesktopManager
{
    private JDesktopPane desktop;

    protected void resizeDeskTop(JComponent actionf)
    {
        int width = desktop.getVisibleRect().width,
            height = desktop.getVisibleRect().height;
        JInternalFrame[] iframes = desktop.getAllFrames();
        for (int i = 0; i < iframes.length; i++)
        {
            if (width < iframes[i].getX() + iframes[i].getWidth())
                width = iframes[i].getX() + iframes[i].getWidth();
            if (height < iframes[i].getY() + iframes[i].getHeight())
                height = iframes[i].getY() + iframes[i].getHeight();
        }
        desktop.setPreferredSize(new Dimension(width, height));
        desktop.setSize(new Dimension(width, height));
    }

    /**
     * @see javax.swing.DesktopManager#endDraggingFrame(JComponent)
     */
    public void endDraggingFrame(JComponent f)
    {
        super.endDraggingFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#endResizingFrame(JComponent)
     */
    public void endResizingFrame(JComponent f)
    {
        super.endResizingFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#openFrame(JInternalFrame)
     */
    public void openFrame(JInternalFrame f)
    {
        super.openFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#activateFrame(JInternalFrame)
     */
    public void activateFrame(JInternalFrame f)
    {
        super.activateFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#closeFrame(JInternalFrame)
     */
    public void closeFrame(JInternalFrame f)
    {
        super.closeFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#deiconifyFrame(JInternalFrame)
     */
    public void deiconifyFrame(JInternalFrame f)
    {
        super.deiconifyFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#iconifyFrame(JInternalFrame)
     */
    public void iconifyFrame(JInternalFrame f)
    {
        super.iconifyFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#maximizeFrame(JInternalFrame)
     */
    public void maximizeFrame(JInternalFrame f)
    {
        super.maximizeFrame(f);
        resizeDeskTop(f);
    }

    /**
     * @see javax.swing.DesktopManager#minimizeFrame(JInternalFrame)
     */
    public void minimizeFrame(JInternalFrame f)
    {
        super.minimizeFrame(f);
        resizeDeskTop(f);
    }

    /**
     * 
     * @param desktop 
     */
    public TPDesktopManager(JDesktopPane desktop)
    {
        this.desktop = desktop;
    }
}
