package tinyPainter.dialog;

import java.util.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class Resource
{
    private static ResourceBundle resources;

    public static String DialogOK;
    public static String DialogCancel;

    public static String FontDialogTitle;
    public static String FontStyleBold;
    public static String FontStyleItalic;

    static {
        try
        {
            resources =
                ResourceBundle.getBundle(
                    "tinyPainter.resource.tinyPainter",
                    Locale.getDefault());

            DialogOK = resources.getString("DialogOK");
            DialogCancel = resources.getString("DialogCancel");

            FontDialogTitle = resources.getString("FontDialogTitle");
            FontStyleBold = resources.getString("FontStyleBold");
            FontStyleItalic = resources.getString("FontStyleItalic");
        }
        catch (MissingResourceException mre)
        {
            JOptionPane.showMessageDialog(
                null,
                "Error loading resources, program terminated!",
                "Fatal",
                JOptionPane.ERROR_MESSAGE);
            mre.printStackTrace();
            System.exit(1);
        }
    }
}
