package tinyPainter.dialog;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Իģ
 * @author gameboy<p>
 * Created on 2002-12-12
 */
abstract public class TPDialog extends JDialog
{
    /**
     * ȡָرնԻ
     */
    public static final int CANCEL_OPTION = 0;
    /**
     * ȷָرնԻ
     */
    public static final int OK_OPTION = 1;
    protected int returnValue;
    protected JButton jbOK;
    protected JButton jbCancel;
    /**
     * ʾԻ
     * @return Իرշʽ<code>OK_OPTION</code><code> CANCEL_OPTION</code>
     * @see #OK_OPTION
     * @see #CANCEL_OPTION
     */
    public int showDialog()
    {
        returnValue = CANCEL_OPTION;
        try
        {
            setLocation(
                getParent().getX() + (getParent().getWidth() - getWidth()) / 2,
                getParent().getY()
                    + (getParent().getHeight() - getHeight()) / 2);
        }
        catch (NullPointerException e)
        {
            setLocation(
                (Toolkit.getDefaultToolkit().getScreenSize().width
                    - getWidth())
                    / 2,
                (Toolkit.getDefaultToolkit().getScreenSize().height
                    - getHeight())
                    / 2);
        }
        SwingUtilities.updateComponentTreeUI(this);
        show();
        return returnValue;
    }
    /**
     * Իȷȡť¼Ӧ
     * @param 
     */
    public TPDialog(Frame parent)
    {
        super(parent, true);
        jbOK = new JButton(Resource.DialogOK);
        jbOK.setSize(80, 30);
        jbOK.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent arg0)
            {
                returnValue = OK_OPTION;
                setVisible(false);
            }
        });

        getRootPane().setDefaultButton(jbOK);

        jbCancel = new JButton(Resource.DialogCancel);
        jbCancel.setSize(80, 30);
        jbCancel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent arg0)
            {
                returnValue = CANCEL_OPTION;
                setVisible(false);
            }
        });
    }

}
