package components.toolbox;

import skeleton.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class ButtonPanel extends JPanel implements ActionListener
{
    private JToggleButton[] jtbTool;
    private ButtonGroup bgGroup;
    private int index;
    private static final int ToolCount = 15;
    private ToolBoxPanel parent;

    public void actionPerformed(ActionEvent e)
    {
        parent.getFrame().getAnimation().getSlidePanel().confirmAll();

        for (int i = 0; i < ToolCount; i++)
        {
            if (e.getSource() == jtbTool[i])
                index = i;
        }

        switch (index)
        {
            case 0 :
            case 2 :
            case 3 :
            case 4 :
            case 8 :
            case 11 :
            case 14 :
                parent.showNothing();
                break;
            case 1 :
            case 5 :
            case 6 :
            case 7 :
            case 9 :
            case 10 :
            case 12 :
            case 13 :
                parent.showLine();
                break;
        }
    }

    public int getCurrentToolIndex()
    {
        return index;
    }

    public void setCurrentToolIndex(int Index)
    {
        jtbTool[index = Index].setSelected(true);
    }

    protected ButtonPanel(ToolBoxPanel owner)
    {
        parent = owner;

        jtbTool = new JToggleButton[15];
        bgGroup = new ButtonGroup();
        index = 1;

        jtbTool[0] = new JToggleButton(Resource.IconToolBoxSelect);
        jtbTool[1] = new JToggleButton(Resource.IconToolBoxBrush);
        jtbTool[2] = new JToggleButton(Resource.IconToolBoxEyedropper);
        jtbTool[3] = new JToggleButton(Resource.IconToolBoxPaint);
        jtbTool[4] = new JToggleButton(Resource.IconToolBoxText);
        jtbTool[5] = new JToggleButton(Resource.IconToolBoxLine);
        jtbTool[6] = new JToggleButton(Resource.IconToolBoxRectangleHollow);
        jtbTool[7] = new JToggleButton(Resource.IconToolBoxRectangleOutlined);
        jtbTool[8] = new JToggleButton(Resource.IconToolBoxRectangleFilled);
        jtbTool[9] = new JToggleButton(Resource.IconToolBoxRoundRectHollow);
        jtbTool[10] = new JToggleButton(Resource.IconToolBoxRoundRectOutlined);
        jtbTool[11] = new JToggleButton(Resource.IconToolBoxRoundRectFilled);
        jtbTool[12] = new JToggleButton(Resource.IconToolBoxCircleHollow);
        jtbTool[13] = new JToggleButton(Resource.IconToolBoxCircleOutlined);
        jtbTool[14] = new JToggleButton(Resource.IconToolBoxCircleFilled);

        jtbTool[0].setToolTipText(Resource.ToolTipToolBoxSelect);
        jtbTool[1].setToolTipText(Resource.ToolTipToolBoxBrush);
        jtbTool[2].setToolTipText(Resource.ToolTipToolBoxEyedropper);
        jtbTool[3].setToolTipText(Resource.ToolTipToolBoxPaint);
        jtbTool[4].setToolTipText(Resource.ToolTipToolBoxText);
        jtbTool[5].setToolTipText(Resource.ToolTipToolBoxLine);
        jtbTool[6].setToolTipText(Resource.ToolTipToolBoxRectHollow);
        jtbTool[7].setToolTipText(Resource.ToolTipToolBoxRectOutlined);
        jtbTool[8].setToolTipText(Resource.ToolTipToolBoxRectFilled);
        jtbTool[9].setToolTipText(Resource.ToolTipToolBoxRoundRectHollow);
        jtbTool[10].setToolTipText(Resource.ToolTipToolBoxRoundRectOutlined);
        jtbTool[11].setToolTipText(Resource.ToolTipToolBoxRoundRectFilled);
        jtbTool[12].setToolTipText(Resource.ToolTipToolBoxCircleHollow);
        jtbTool[13].setToolTipText(Resource.ToolTipToolBoxCircleOutlined);
        jtbTool[14].setToolTipText(Resource.ToolTipToolBoxCircleFilled);

        setLayout(new GridLayout(5, 3));
        for (int i = 0; i < ToolCount; i++)
        {
            bgGroup.add(jtbTool[i]);
            jtbTool[i].setPreferredSize(
                new Dimension(
                    Resource.ToolBoxButtonWidth,
                    Resource.ToolBoxButtonHeight));
            jtbTool[i].addActionListener(this);
            add(jtbTool[i]);
        }

        jtbTool[1].setSelected(true);
    }
}
