package fclipboard;

import java.io.*;
import java.util.ArrayList;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>Description goes here</p>*/
public class FClipOutputStream extends OutputStream
{
    private ArrayList clipdata;

    protected FClipOutputStream()
    {
        clipdata = new ArrayList(4096);
    }

    public void close()
    {
        byte[] data = new byte[clipdata.size()];

        for (int i = 0; i < data.length; i++)
            data[i] = ((Byte) (clipdata.get(i))).byteValue();

        setClipboardData(data);
    }

    public void flush()
    {}

    public void write(byte[] b)
    {
        write(b, 0, b.length);
    }

    public void write(byte[] b, int off, int len)
    {
        for (int i = 0; i < len; i++)
            write(b[i + off]);
    }

    public void write(int b)
    {
        int data = b;
        if (data > 127)
            data -= 128;

        clipdata.add(new Byte((byte) data));
    }

    private static native void setClipboardData(byte[] data);
    static {
        java
            .security
            .AccessController
            .doPrivileged(new java.security.PrivilegedAction()
        {
            public Object run()
            {
                System.loadLibrary("FClip");
                return null;
            }
        });
    }
}
