package msicon;

import java.io.*;
import java.util.*;

/**
 * @author 
 * <p>&copy;Ȩ 2002, 2003
 * 廪ѧѧԺ</p>
 * @version
 * 1.00
 * <p>࣬
 * ڹļݡ</p>*/
public class MSAni implements Serializable
{
    private ArrayList Icon;
    private ArrayList Rate;
    private String NameInfo;
    private String ArtInfo;

    /**һնļ
     * ע⣬һ֡ſԴ̡*/
    public MSAni()
    {
        NameInfo = null;
        ArtInfo = null;
        Icon = new ArrayList();
        Rate = new ArrayList();
    }

    /**ʹù괴һ֡ļ*/
    public MSAni(MSIcon Data)
    {
        NameInfo = null;
        ArtInfo = null;
        Icon = new ArrayList();
        Data.setCursor();
        Icon.add(Data);
        Rate = new ArrayList();
        Rate.add(new Integer(2));
    }

    /**ʹù鴴ļ
     * ÿ֡ͼ񲥷100롣*/
    public MSAni(ArrayList Data) throws RuntimeException
    {
        NameInfo = null;
        ArtInfo = null;
        try
        {
            MSIcon msid;
            Rate = new ArrayList();
            for (int i = 0; i < Data.size(); i++)
            {
                msid = (MSIcon) (Data.get(i));
                Rate.add(new Integer(2));
            }

            Icon = Data;
        }
        catch (RuntimeException e)
        {
            throw e;
        }
    }

    /**ʹù͸֡ʱ鴴ļ*/
    public MSAni(ArrayList Data, ArrayList rate) throws RuntimeException
    {
        NameInfo = null;
        ArtInfo = null;
        try
        {
            MSIcon msid;
            Integer test;
            for (int i = 0; i < Data.size(); i++)
            {
                msid = (MSIcon) (Data.get(i));
                test = (Integer) (Rate.get(i));
                if (test.intValue() <= 0)
                    throw new RuntimeException();
            }

            Icon = Data;
            Rate = rate;
        }
        catch (RuntimeException e)
        {
            throw e;
        }
    }

    /**ļװһꡣ*/
    public MSAni(String filename) throws Exception
    {
        NameInfo = null;
        ArtInfo = null;
        if (!flowIn(filename))
            throw new Exception();
    }

    /**һ֡ӵУ
     * ֵΪռݡ*/
    public MSIcon add(MSIcon data, int rate)
    {
        if (rate <= 0 || data == null)
            return null;

        data.setCursor();
        Icon.add(data);
        Rate.add(new Integer(rate));
        return data;
    }

    /**һ֡ӵУ
     * ֵΪռݡ*/
    public MSIcon add(int index, MSIcon data, int rate)
    {
        if (rate <= 0 || data == null)
            return null;

        data.setCursor();
        Icon.add(index, data);
        Rate.add(index, new Integer(rate));
        return data;
    }

    /**һ֡Ӷɾ
     * ֵΪɾĹꡣ
     * ָڶвڣ
     * 򷵻<code>null</code>*/
    public MSIcon remove(int index)
    {
        try
        {
            MSIcon msi = (MSIcon) (Icon.get(index));
            Icon.remove(index);
            Rate.remove(index);
            return msi;
        }
        catch (Exception e)
        {
            return null;
        }
    }

    /**һ֡Ӷɾ
     * ֵΪɾĹꡣ
     * ָڶвڣ
     * 򷵻<code>null</code>*/
    public MSIcon remove(MSIcon data)
    {
        if (Icon.indexOf(data) == -1)
            return null;

        Icon.remove(data);
        Rate.remove(Icon.indexOf(data));

        return data;
    }

    /**ȡļеĹ֡*/
    public int getFrameCount()
    {
        return Icon.size();
    }

    /**ص<code>index-1</code>֡ꡣ*/
    public MSIcon getCursor(int index)
    {
        return (MSIcon) (Icon.get(index));
    }

    /**޸ĵ<code>index-1</code>֡ꡣ*/
    public MSIcon setCursor(int index, MSIconData data)
    {
        return (MSIcon) (Icon.set(index, data));
    }

    /**޸ĵ<code>index-1</code>֡Ĳʱ䡣*/
    public int getRate(int index)
    {
        return ((Integer) (Rate.get(index))).intValue();
    }

    /**޸ĵ<code>index-1</code>֡Ĳʱ䡣
     * ֵΪռݡ*/
    public int setRate(int index, int rate)
    {
        if (rate <= 0)
            return getRate(index);

        Rate.set(index, new Integer(rate));
        return rate;
    }

    /**öݴļ뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowIn(String filename)
    {

        try
        {
            DataInputStream dis =
                new DataInputStream(new FileInputStream(filename));
            boolean result = flowIn(dis);
            dis.close();
            return result;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ö뵽ڴС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowIn(DataInputStream dis)
    {
        Icon = new ArrayList();
        Rate = new ArrayList();
        System.gc();

        boolean dataRead = false;
        int iconNum = 0;

        try
        {
            if (!Utilities.readString(4, dis).equals("RIFF"))
                throw new Exception();

            dis.skipBytes(4);

            if (!Utilities.readString(4, dis).equals("ACON"))
                throw new Exception();

            boolean dataReady = false;
            boolean infoReady = false;

            while (!dataRead)
            {
                String Varify = Utilities.readString(4, dis);

                if (Varify.equals("anih"))
                {
                    dis.skipBytes(8);
                    iconNum = Utilities.readInt(dis);
                    dis.skipBytes(28);
                    dataReady = true;
                }
                else if (Varify.equals("rate"))
                {
                    int Length = Utilities.readInt(dis);

                    for (int i = 0; i < Length / 4; i++)
                        Rate.add(new Integer(Utilities.readInt(dis)));
                }
                else if (Varify.equals("LIST"))
                {
                    if (dataReady)
                    {
                        dis.skipBytes(4);
                        for (int i = 0; i < iconNum; i++)
                        {
                            String varify = Utilities.readString(4, dis);
                            if (varify.equals("fram"))
                                dis.skipBytes(8);
                            else
                                dis.skipBytes(4);

                            MSIcon msi = new MSIcon();
                            if (!msi.flowIn(dis))
                                throw new Exception();

                            Icon.add(msi);
                        }

                        dataRead = true;
                    }
                    else
                    {
                        dis.skipBytes(4);
                        infoReady = true;
                    }
                }
                else if (infoReady && Varify.equals("INFO"))
                {
                    int size;
                    dis.skipBytes(4);
                    NameInfo =
                        Utilities.readString(
                            size = Utilities.readInt(dis),
                            dis);
                    dis.skipBytes(4 + size % 2);

                    ArtInfo =
                        Utilities.readString(
                            size = Utilities.readInt(dis),
                            dis);
                    dis.skipBytes(size % 2);

                    NameInfo = Utilities.fixString(NameInfo);
                    ArtInfo = Utilities.fixString(ArtInfo);
                }
                else
                    dis.skipBytes(Utilities.readInt(dis));
            }

            for (int i = Rate.size(); i < iconNum; i++)
                Rate.add(new Integer(2));

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**öļС
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowOut(String filename)
    {
        try
        {
            DataOutputStream dos =
                new DataOutputStream(new FileOutputStream(filename));
            boolean result = flowOut(dos);
            dos.close();
            return result;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**öָص㡣
     * ɹ򷵻<code>true</code>
     * ʧܣ򷵻<code>false</code>*/
    public boolean flowOut(DataOutputStream dos)
    {
        if (Icon.size() == 0)
            return false;

        try
        {
            dos.writeBytes("RIFF");
            Utilities.writeInt(getAniSize(), dos);

            dos.writeBytes("ACON");

            if (NameInfo != null || ArtInfo != null)
            {
                dos.writeBytes("LIST");
                Utilities.writeInt(getDescriptionSize(), dos);
                dos.writeBytes("INFOINAM");

                int size = 0;

                if (NameInfo != null)
                {
                    Utilities.writeInt(
                        size = (NameInfo.getBytes().length + 1),
                        dos);
                    dos.write(NameInfo.getBytes());
                }
                else
                    Utilities.writeInt(1, dos);
                dos.writeByte(0);
                if (size % 2 != 0)
                    dos.writeByte(0);

                dos.writeBytes("IART");

                if (ArtInfo != null)
                {
                    Utilities.writeInt(
                        size = (ArtInfo.getBytes().length + 1),
                        dos);
                    dos.write(ArtInfo.getBytes());
                }
                else
                    Utilities.writeInt(1, dos);
                if (size % 2 != 0)
                    dos.writeByte(0);
                dos.writeByte(0);
            }

            dos.writeBytes("anih");
            Utilities.writeInt(36, dos);
            Utilities.writeInt(36, dos);
            Utilities.writeInt(Icon.size(), dos);
            Utilities.writeInt(Icon.size(), dos);

            for (int i = 0; i < 16; i++)
                dos.writeByte(0);

            Utilities.writeInt(2, dos);
            Utilities.writeInt(1, dos);

            dos.writeBytes("rate");
            Utilities.writeInt(Icon.size() * 4, dos);
            for (int i = 0; i < Icon.size(); i++)
                Utilities.writeInt(((Integer) (Rate.get(i))).intValue(), dos);

            dos.writeBytes("LIST");
            Utilities.writeInt(getCursorsSize(), dos);
            dos.writeBytes("fram");

            for (int i = 0; i < Icon.size(); i++)
            {
                MSIcon msi = (MSIcon) (Icon.get(i));
                dos.writeBytes("icon");
                Utilities.writeInt(msi.getIconSize(), dos);

                if (!msi.flowOut(dos))
                    throw new Exception();
            }

            return true;
        }
        catch (Exception e)
        {
            return false;
        }
    }

    /**ȡļϢ*/
    public String getNameInfo()
    {
        return NameInfo;
    }

    /**ļϢ*/
    public String setNameInfo(String info)
    {
        return NameInfo = info;
    }

    /**ȡļϢ*/
    public String getArtInfo()
    {
        return ArtInfo;
    }

    /**ļϢ*/
    public String setArtInfo(String info)
    {
        return ArtInfo = info;
    }

    /**ȡļϢС*/
    private int getDescriptionSize()
    {
        int Size = 20;
        int size = 0;
        if (NameInfo == null)
            Size += 1;
        else
            Size += (size = (NameInfo.getBytes().length + 1));

        if (size % 2 != 0)
            Size++;

        if (ArtInfo == null)
            Size += 1;
        else
            Size += (size = (ArtInfo.getBytes().length + 1));

        if (size % 2 != 0)
            Size++;

        return Size;
    }

    /**ȡݿС*/
    private int getCursorsSize()
    {
        int size = 4;
        for (int i = 0; i < Icon.size(); i++)
            size += ((MSIcon) (Icon.get(i))).getIconSize() + 8;
        return size;
    }

    /**ȡļС*/
    protected int getAniSize()
    {
        //С
        int size = 8 + getCursorsSize();

        //ʱݿС
        size += Icon.size() * 4 + 8;

        //ļϢС
        if (NameInfo != null || ArtInfo != null)
            size += getDescriptionSize() + 8;

        //ļͷС
        size += 56;

        return size;
    }
}
