/**
 * @author 
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

package skeleton;
import java.awt.*;
import java.util.*;
import javax.swing.*;

public class Resource
{
    private static ResourceBundle resources;

    //ָ
    public static final Cursor CursorCross =
        new Cursor(Cursor.CROSSHAIR_CURSOR);
    public static final Cursor CursorMove = new Cursor(Cursor.MOVE_CURSOR);
    public static final Cursor CursorEyedropper =
        Toolkit.getDefaultToolkit().createCustomCursor(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/cursor_eyedropper.gif")),
            new Point(1, 30),
            "Allegretto_Custom_Cursor_EyeDropper");
    public static final Cursor CursorPaint =
        Toolkit.getDefaultToolkit().createCustomCursor(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/cursor_paint.gif")),
            new Point(2, 31),
            "Allegretto_Custom_Cursor_Paint");

    //
    public static final int StatusBarHeight = 18;
    public static final int FrameInitialWidth = 640;
    public static final int FrameInitialHeight = 480;

    public static final int AnimationPanelWidth = 320;
    public static final int AnimationPanelHeight = 60;

    public static final int ToolBoxButtonWidth = 28;
    public static final int ToolBoxButtonHeight = 28;

    public static final int EditPanelPixelSize = 8;
    
    public static final int MaxUndoDepth = 10;

    //ַ
    public static String AppName;

    public static String DescriptionIconFile;
    public static String DescriptionCursorFile;
    public static String DescriptionAnimationFile;
    public static String DescriptionDllFile;
    public static String DescriptionExeFile;

    public static String StatusReady;

    public static String ErrorImportFrame;
    public static String ErrorExportFrame;

    //ڱ
    public static String TitleAnimation;
    public static String TitleEditor;

    //˵
    public static String MenuFile;

    public static String MenuFileNew;
    public static String ToolTipMenuFileNew;
    public static String MenuFileOpen;
    public static String ToolTipMenuFileOpen;
    public static String MenuFileSave;
    public static String ToolTipMenuFileSave;
    public static String MenuFileSaveAs;
    public static String ToolTipMenuFileSaveAs;
    public static String MenuFileInfo;
    public static String ToolTipMenuFileInfo;
    public static String MenuFileMouseSetting;
    public static String ToolTipMenuFileMouseSetting;
    public static String MenuFileExit;
    public static String ToolTipMenuFileExit;

    public static String MenuEdit;

    public static String MenuEditUndo;
    public static String ToolTipMenuEditUndo;
    public static String MenuEditRedo;
    public static String ToolTipMenuEditRedo;
    public static String MenuEditModify;
    public static String ToolTipMenuEditModify;
    public static String MenuEditCut;
    public static String ToolTipMenuEditCut;
    public static String MenuEditCopy;
    public static String ToolTipMenuEditCopy;
    public static String MenuEditPaste;
    public static String ToolTipMenuEditPaste;
    public static String MenuEditClear;
    public static String ToolTipMenuEditClear;
    public static String MenuEditSelAll;
    public static String ToolTipMenuEditSelAll;
    public static String MenuEditInsertFrame;
    public static String ToolTipMenuEditInsertFrame;
    public static String MenuEditDeleteFrame;
    public static String ToolTipMenuEditDeleteFrame;
    public static String MenuEditImport;
    public static String ToolTipMenuEditImport;
    public static String MenuEditExport;
    public static String ToolTipMenuEditExport;

    public static String MenuImage;

    public static String MenuImageMode;
    public static String ToolTipMenuImageMode;
    public static String MenuImageInsert;
    public static String ToolTipMenuImageInsert;
    public static String MenuImageDelete;
    public static String ToolTipMenuImageDelete;
    public static String MenuImageRotate;
    public static String ToolTipMenuImageRotate;
    public static String MenuImageRotate90CW;
    public static String ToolTipMenuImageRotate90CW;
    public static String MenuImageRotate90ACW;
    public static String ToolTipMenuImageRotate90ACW;
    public static String MenuImageRotate180;
    public static String ToolTipMenuImageRotate180;
    public static String MenuImageFlip;
    public static String ToolTipMenuImageFlip;
    public static String MenuImageFlipHorizontal;
    public static String ToolTipMenuImageFlipHorizontal;
    public static String MenuImageFlipVertical;
    public static String ToolTipMenuImageFlipVertical;
    public static String MenuImageInvert;
    public static String ToolTipMenuImageInvert;
    public static String MenuImageHotspot;
    public static String ToolTipMenuImageHotspot;
    public static String MenuImageExtract;
    public static String ToolTipMenuImageExtract;

    public static String MenuView;

    public static String MenuViewStatusBar;
    public static String ToolTipMenuViewStatusBar;
    public static String MenuViewAnimation;
    public static String ToolTipMenuViewAnimation;
    public static String MenuViewToolBox;
    public static String ToolTipMenuViewToolBox;
    public static String MenuViewPalette;
    public static String ToolTipMenuViewPalette;
    public static String MenuViewPreview;
    public static String ToolTipMenuViewPreview;
    public static String MenuViewGrid;
    public static String ToolTipMenuViewGrid;

    public static String MenuViewLookAndFeel;
    public static String ToolTipMenuViewLookAndFeel;

    public static String MenuHelp;

    public static String MenuHelpContent;
    public static String ToolTipMenuHelpContent;

    public static String MenuHelpAbout;
    public static String ToolTipMenuHelpAbout;

    //ݲ˵
    public static String PopupMenuInsertFrame;
    public static String PopupMenuDeleteFrame;
    public static String PopupMenuImportFrame;
    public static String PopupMenuExportFrame;

    //ԻԴ
    public static String AnimationPanelRate;
    public static String AnimationPanelUnit;
    public static String AnimationPanelApply;

    public static String PaletteTitle;

    public static String Palette2Color;
    public static String Palette16Color;
    public static String Palette256Color;
    public static String PaletteTrueColor;

    public static String PaletteTransparent;

    public static String PaletteBackground;
    public static String PaletteForeground;

    public static String FormatCurColors;
    public static String FormatDialogTitle;
    public static String FormatImageColors;
    public static String FormatPaletteType;
    public static String FormatPaletteStandard;
    public static String FormatPaletteOptimized;
    public static String FormatImageSize;
    public static String FormatImageSizeSmall;
    public static String FormatImageSizeNormal;
    public static String FormatImageSizeLarge;
    public static String FormatImageSizeCustom;
    public static String FormatIllegalSize;

    public static String DialogOK;
    public static String DialogCancel;

    public static String FileInfoDialogTitle;
    public static String FileInfoFileInfo;
    public static String FileInfoArtInfo;

    public static String ExtractDialogTitle;
    public static String ExtractNoIcon;

    public static String CantLoadHelpFile;

    //ťʾ
    public static String ToolTipToolBoxSelect;
    public static String ToolTipToolBoxBrush;
    public static String ToolTipToolBoxEyedropper;
    public static String ToolTipToolBoxPaint;
    public static String ToolTipToolBoxText;
    public static String ToolTipToolBoxLine;
    public static String ToolTipToolBoxRectHollow;
    public static String ToolTipToolBoxRectOutlined;
    public static String ToolTipToolBoxRectFilled;
    public static String ToolTipToolBoxRoundRectHollow;
    public static String ToolTipToolBoxRoundRectOutlined;
    public static String ToolTipToolBoxRoundRectFilled;
    public static String ToolTipToolBoxCircleHollow;
    public static String ToolTipToolBoxCircleOutlined;
    public static String ToolTipToolBoxCircleFilled;

    //
    public static String AboutDlgTitle;
    public static String AboutDlgContent;

    //ͼƬ
    public static final Image IconMainFrame =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/mainframe.gif"));

    //ͼƬ
    public static final Image ImageLineWidth =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/linewidth.gif"));
    public static final Image ImageBrushShape =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/brushshape.gif"));

    public static final Image ImageHotspot =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/hotspot.gif"));

    //ͼ
    public static final ImageIcon IconAllegretto =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/allegretto.gif")));
    public static final ImageIcon IconChildFrame =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/childframe.gif")));
    public static final ImageIcon IconEditor =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/editor.gif")));

    public static final ImageIcon IconNull =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/null.gif")));

    public static final ImageIcon IconToolBarNew =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_new.gif")));
    public static final ImageIcon IconToolBarOpen =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_open.gif")));
    public static final ImageIcon IconToolBarSave =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_save.gif")));
    public static final ImageIcon IconToolBarInfo =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_info.gif")));
    public static final ImageIcon IconToolBarPreview =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_preview.gif")));
    public static final ImageIcon IconToolBarUndo =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_undo.gif")));
    public static final ImageIcon IconToolBarRedo =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_redo.gif")));
    public static final ImageIcon IconToolBarCut =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_cut.gif")));
    public static final ImageIcon IconToolBarCopy =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_copy.gif")));
    public static final ImageIcon IconToolBarPaste =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_paste.gif")));
    public static final ImageIcon IconToolBarInsertFrame =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_insertframe.gif")));
    public static final ImageIcon IconToolBarDeleteFrame =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_deleteframe.gif")));
    public static final ImageIcon IconToolBarMode =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_mode.gif")));
    public static final ImageIcon IconToolBarInsertImage =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_insertimage.gif")));
    public static final ImageIcon IconToolBarDeleteImage =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_deleteimage.gif")));
    public static final ImageIcon IconToolBarRotate90CW =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_rotate90cw.gif")));
    public static final ImageIcon IconToolBarRotate90ACW =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_rotate90acw.gif")));
    public static final ImageIcon IconToolBarRotate180 =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_rotate180.gif")));
    public static final ImageIcon IconToolBarFlipHorizontal =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_fliphorizontal.gif")));
    public static final ImageIcon IconToolBarFlipVertical =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tb_flipvertical.gif")));
    public static final ImageIcon IconToolBarInvert =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_invert.gif")));
    public static final ImageIcon IconToolBarHotspot =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_hotspot.gif")));
    public static final ImageIcon IconToolBarAnimation =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_animation.gif")));
    public static final ImageIcon IconToolBarToolBox =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_toolbox.gif")));
    public static final ImageIcon IconToolBarPalette =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_palette.gif")));
    public static final ImageIcon IconToolBarGrid =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_grid.gif")));
    public static final ImageIcon IconToolBarContent =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_content.gif")));
    public static final ImageIcon IconToolBarAbout =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tb_about.gif")));

    public static final ImageIcon IconToolBoxSelect =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tool_select.gif")));
    public static final ImageIcon IconToolBoxBrush =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tool_brush.gif")));
    public static final ImageIcon IconToolBoxEyedropper =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_eyedropper.gif")));
    public static final ImageIcon IconToolBoxPaint =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tool_paint.gif")));
    public static final ImageIcon IconToolBoxText =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tool_text.gif")));
    public static final ImageIcon IconToolBoxLine =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource("/resource/images/tool_line.gif")));
    public static final ImageIcon IconToolBoxRectangleHollow =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_rectangle_hollow.gif")));
    public static final ImageIcon IconToolBoxRectangleOutlined =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_rectangle_outlined.gif")));
    public static final ImageIcon IconToolBoxRectangleFilled =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_rectangle_filled.gif")));
    public static final ImageIcon IconToolBoxRoundRectHollow =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_roundrect_hollow.gif")));
    public static final ImageIcon IconToolBoxRoundRectOutlined =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_roundrect_outlined.gif")));
    public static final ImageIcon IconToolBoxRoundRectFilled =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_roundrect_filled.gif")));
    public static final ImageIcon IconToolBoxCircleHollow =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_circle_hollow.gif")));
    public static final ImageIcon IconToolBoxCircleOutlined =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_circle_outlined.gif")));
    public static final ImageIcon IconToolBoxCircleFilled =
        new ImageIcon(
            Toolkit.getDefaultToolkit().createImage(
                Image.class.getResource(
                    "/resource/images/tool_circle_filled.gif")));

    public static final Image ImagePaletteSampleRed =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_red.gif"));
    public static final Image ImagePaletteSampleGreen =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_green.gif"));
    public static final Image ImagePaletteSampleBlue =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_blue.gif"));

    public static final Image ImagePaletteChooserRed =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_sel_red.gif"));
    public static final Image ImagePaletteChooserGreen =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_sel_green.gif"));
    public static final Image ImagePaletteChooserBlue =
        Toolkit.getDefaultToolkit().createImage(
            Image.class.getResource("/resource/images/palette_sel_blue.gif"));

    static {
        try
        {
            resources =
                ResourceBundle.getBundle(
                    "resource.Allegretto",
                    Locale.getDefault());

            AppName = resources.getString("AppName");
            StatusReady = resources.getString("StatusReady");
            DescriptionIconFile = resources.getString("DescriptionIconFile");
            DescriptionCursorFile =
                resources.getString("DescriptionCursorFile");
            DescriptionAnimationFile =
                resources.getString("DescriptionAnimationFile");
            DescriptionDllFile = resources.getString("DescriptionDllFile");
            DescriptionExeFile = resources.getString("DescriptionExeFile");

            TitleAnimation = resources.getString("TitleAnimation");

            MenuFile = resources.getString("MenuFile");

            MenuFileNew = resources.getString("MenuFileNew");
            ToolTipMenuFileNew = resources.getString("ToolTipMenuFileNew");

            MenuFileOpen = resources.getString("MenuFileOpen");
            ToolTipMenuFileOpen = resources.getString("ToolTipMenuFileOpen");

            MenuFileSave = resources.getString("MenuFileSave");
            ToolTipMenuFileSave = resources.getString("ToolTipMenuFileSave");

            MenuFileSaveAs = resources.getString("MenuFileSaveAs");
            ToolTipMenuFileSaveAs =
                resources.getString("ToolTipMenuFileSaveAs");

            MenuFileInfo = resources.getString("MenuFileInfo");
            ToolTipMenuFileInfo = resources.getString("ToolTipMenuFileInfo");

            MenuFileMouseSetting = resources.getString("MenuFileMouseSetting");
            ToolTipMenuFileMouseSetting =
                resources.getString("ToolTipMenuFileMouseSetting");

            MenuFileExit = resources.getString("MenuFileExit");
            ToolTipMenuFileExit = resources.getString("ToolTipMenuFileExit");

            MenuEdit = resources.getString("MenuEdit");

            MenuEditUndo = resources.getString("MenuEditUndo");
            ToolTipMenuEditUndo = resources.getString("ToolTipMenuEditUndo");

            MenuEditRedo = resources.getString("MenuEditRedo");
            ToolTipMenuEditRedo = resources.getString("ToolTipMenuEditRedo");

            MenuEditModify = resources.getString("MenuEditModify");
            ToolTipMenuEditModify =
                resources.getString("ToolTipMenuEditModify");

            MenuEditCut = resources.getString("MenuEditCut");
            ToolTipMenuEditCut = resources.getString("ToolTipMenuEditCut");

            MenuEditCopy = resources.getString("MenuEditCopy");
            ToolTipMenuEditCopy = resources.getString("ToolTipMenuEditCopy");

            MenuEditPaste = resources.getString("MenuEditPaste");
            ToolTipMenuEditPaste = resources.getString("ToolTipMenuEditPaste");

            MenuEditClear = resources.getString("MenuEditClear");
            ToolTipMenuEditClear = resources.getString("ToolTipMenuEditClear");

            MenuEditSelAll = resources.getString("MenuEditSelAll");
            ToolTipMenuEditSelAll =
                resources.getString("ToolTipMenuEditSelAll");

            MenuEditInsertFrame = resources.getString("MenuEditInsertFrame");
            ToolTipMenuEditInsertFrame =
                resources.getString("ToolTipMenuEditInsertFrame");

            MenuEditDeleteFrame = resources.getString("MenuEditDeleteFrame");
            ToolTipMenuEditDeleteFrame =
                resources.getString("ToolTipMenuEditDeleteFrame");

            MenuEditImport = resources.getString("MenuEditImport");
            ToolTipMenuEditImport =
                resources.getString("ToolTipMenuEditImport");

            MenuEditExport = resources.getString("MenuEditExport");
            ToolTipMenuEditExport =
                resources.getString("ToolTipMenuEditExport");

            MenuImage = resources.getString("MenuImage");

            MenuImageMode = resources.getString("MenuImageMode");
            ToolTipMenuImageMode = resources.getString("ToolTipMenuImageMode");

            MenuImageInsert = resources.getString("MenuImageInsert");
            ToolTipMenuImageInsert =
                resources.getString("ToolTipMenuImageInsert");

            MenuImageDelete = resources.getString("MenuImageDelete");
            ToolTipMenuImageDelete =
                resources.getString("ToolTipMenuImageDelete");

            MenuImageRotate = resources.getString("MenuImageRotate");
            ToolTipMenuImageRotate =
                resources.getString("ToolTipMenuImageRotate");

            MenuImageRotate90CW = resources.getString("MenuImageRotate90CW");
            ToolTipMenuImageRotate90CW =
                resources.getString("ToolTipMenuImageRotate90CW");

            MenuImageRotate90ACW = resources.getString("MenuImageRotate90ACW");
            ToolTipMenuImageRotate90ACW =
                resources.getString("ToolTipMenuImageRotate90ACW");

            MenuImageRotate180 = resources.getString("MenuImageRotate180");
            ToolTipMenuImageRotate180 =
                resources.getString("ToolTipMenuImageRotate180");

            MenuImageFlip = resources.getString("MenuImageFlip");
            ToolTipMenuImageFlip = resources.getString("ToolTipMenuImageFlip");

            MenuImageFlipHorizontal =
                resources.getString("MenuImageFlipHorizontal");
            ToolTipMenuImageFlipHorizontal =
                resources.getString("ToolTipMenuImageFlipHorizontal");

            MenuImageFlipVertical =
                resources.getString("MenuImageFlipVertical");
            ToolTipMenuImageFlipVertical =
                resources.getString("ToolTipMenuImageFlipVertical");

            MenuImageInvert = resources.getString("MenuImageInvert");
            ToolTipMenuImageInvert =
                resources.getString("ToolTipMenuImageInvert");

            MenuImageHotspot = resources.getString("MenuImageHotspot");
            ToolTipMenuImageHotspot =
                resources.getString("ToolTipMenuImageHotspot");

            MenuImageExtract = resources.getString("MenuImageExtract");
            ToolTipMenuImageExtract =
                resources.getString("ToolTipMenuImageExtract");

            MenuView = resources.getString("MenuView");

            MenuViewStatusBar = resources.getString("MenuViewStatusBar");
            ToolTipMenuViewStatusBar =
                resources.getString("ToolTipMenuViewStatusBar");

            MenuViewAnimation = resources.getString("MenuViewAnimation");
            ToolTipMenuViewAnimation =
                resources.getString("ToolTipMenuViewAnimation");

            MenuViewToolBox = resources.getString("MenuViewToolBox");
            ToolTipMenuViewToolBox =
                resources.getString("ToolTipMenuViewToolBox");

            MenuViewPalette = resources.getString("MenuViewPalette");
            ToolTipMenuViewPalette =
                resources.getString("ToolTipMenuViewPalette");

            MenuViewPreview = resources.getString("MenuViewPreview");
            ToolTipMenuViewPreview =
                resources.getString("ToolTipMenuViewPreview");

            MenuViewGrid = resources.getString("MenuViewGrid");
            ToolTipMenuViewGrid = resources.getString("ToolTipMenuViewGrid");

            MenuViewLookAndFeel = resources.getString("MenuViewLookAndFeel");
            ToolTipMenuViewLookAndFeel =
                resources.getString("ToolTipMenuViewLookAndFeel");

            MenuHelp = resources.getString("MenuHelp");

            MenuHelpContent = resources.getString("MenuHelpContent");
            ToolTipMenuHelpContent =
                resources.getString("ToolTipMenuHelpContent");

            MenuHelpAbout = resources.getString("MenuHelpAbout");
            ToolTipMenuHelpAbout = resources.getString("ToolTipMenuHelpAbout");

            PopupMenuInsertFrame = resources.getString("PopupMenuInsertFrame");
            PopupMenuDeleteFrame = resources.getString("PopupMenuDeleteFrame");
            PopupMenuImportFrame = resources.getString("PopupMenuImportFrame");
            PopupMenuExportFrame = resources.getString("PopupMenuExportFrame");

            ErrorImportFrame = resources.getString("ErrorImportFrame");
            ErrorExportFrame = resources.getString("ErrorExportFrame");

            AnimationPanelRate = resources.getString("AnimationPanelRate");
            AnimationPanelUnit = resources.getString("AnimationPanelUnit");
            AnimationPanelApply = resources.getString("AnimationPanelApply");

            ToolTipToolBoxSelect = resources.getString("ToolTipToolBoxSelect");
            ToolTipToolBoxBrush = resources.getString("ToolTipToolBoxBrush");
            ToolTipToolBoxEyedropper =
                resources.getString("ToolTipToolBoxEyedropper");
            ToolTipToolBoxPaint = resources.getString("ToolTipToolBoxPaint");
            ToolTipToolBoxText = resources.getString("ToolTipToolBoxText");
            ToolTipToolBoxLine = resources.getString("ToolTipToolBoxLine");
            ToolTipToolBoxRectHollow =
                resources.getString("ToolTipToolBoxRectHollow");
            ToolTipToolBoxRectOutlined =
                resources.getString("ToolTipToolBoxRectOutlined");
            ToolTipToolBoxRectFilled =
                resources.getString("ToolTipToolBoxRectFilled");
            ToolTipToolBoxRoundRectHollow =
                resources.getString("ToolTipToolBoxRoundRectHollow");
            ToolTipToolBoxRoundRectOutlined =
                resources.getString("ToolTipToolBoxRoundRectOutlined");
            ToolTipToolBoxRoundRectFilled =
                resources.getString("ToolTipToolBoxRoundRectFilled");
            ToolTipToolBoxCircleHollow =
                resources.getString("ToolTipToolBoxCircleHollow");
            ToolTipToolBoxCircleOutlined =
                resources.getString("ToolTipToolBoxCircleOutlined");
            ToolTipToolBoxCircleFilled =
                resources.getString("ToolTipToolBoxCircleFilled");

            PaletteTitle = resources.getString("PaletteTitle");

            Palette2Color = resources.getString("Palette2Color");
            Palette16Color = resources.getString("Palette16Color");
            Palette256Color = resources.getString("Palette256Color");
            PaletteTrueColor = resources.getString("PaletteTrueColor");

            PaletteTransparent = resources.getString("PaletteTransparent");

            PaletteBackground = resources.getString("PaletteBackground");
            PaletteForeground = resources.getString("PaletteForeground");

            TitleEditor = resources.getString("TitleEditor");

            FormatCurColors = resources.getString("FormatCurColors");
            FormatDialogTitle = resources.getString("FormatDialogTitle");
            FormatImageColors = resources.getString("FormatImageColors");
            FormatPaletteType = resources.getString("FormatPaletteType");
            FormatPaletteStandard =
                resources.getString("FormatPaletteStandard");
            FormatPaletteOptimized =
                resources.getString("FormatPaletteOptimized");
            FormatImageSize = resources.getString("FormatImageSize");
            FormatImageSizeSmall = resources.getString("FormatImageSizeSmall");
            FormatImageSizeNormal =
                resources.getString("FormatImageSizeNormal");
            FormatImageSizeLarge = resources.getString("FormatImageSizeLarge");
            FormatImageSizeCustom =
                resources.getString("FormatImageSizeCustom");
            FormatIllegalSize = resources.getString("FormatIllegalSize");

            DialogOK = resources.getString("DialogOK");
            DialogCancel = resources.getString("DialogCancel");

            FileInfoDialogTitle = resources.getString("FileInfoDialogTitle");
            FileInfoFileInfo = resources.getString("FileInfoFileInfo");
            FileInfoArtInfo = resources.getString("FileInfoArtInfo");

            ExtractDialogTitle = resources.getString("ExtractDialogTitle");
            ExtractNoIcon = resources.getString("ExtractNoIcon");

            CantLoadHelpFile = resources.getString("CantLoadHelpFile");

            AboutDlgTitle = resources.getString("AboutDlgTitle");
            AboutDlgContent = resources.getString("AboutDlgContent");
        }
        catch (MissingResourceException mre)
        {
            JOptionPane.showMessageDialog(
                null,
                "Error loading resources, program terminated!",
                "Fatal",
                JOptionPane.ERROR_MESSAGE);
            mre.printStackTrace();
            System.exit(1);
        }
    }
}
